# Data Object - ClusterVmComponentProtectionSettings(vim.cluster.VmComponentProtectionSettings)

Property of
  ClusterDasVmSettings
Extends
  DynamicData
Since
  vSphere API 6.0

## Data Object Description

vSphere HA Virtual Machine Component Protection Service settings.

vSphere HA Virtual Machine Component Protection Service detects and reacts to storage failures that do not necessarily cause a virtual machine to go down, but may impact the health or QoS of the virtual machine.

All fields are defined as optional. In case of a reconfiguration, fields left unset are not changed.

Properties

Name | Type | Description
--- | --- | ---
enableAPDTimeoutForHosts* | xsd:boolean | This property indicates if APD timeout will be enabled for all the hosts in the cluster when vSphere HA is configured. The details of APD timeout are described in HostMountInfoInaccessibleReason. If vmComponentProtecting is DasConfigInfo.ServiceState#disabled, the property will be ignored. Otherwise, for each host in the cluster, APD timeout will be enabled. Note that no change will be made for a host if it already had APD timeout enabled. This property is meaningful only for cluster setting. It is ignored if specified at VM level. The default value is false if not specified. Note that this property is not persisted by vSphere backend. It does not impact any cluster reconfiguration or host operation (such as adding a host to a cluster) that might happen later.
vmReactionOnAPDCleared* | xsd:string | Action taken by VM Component Protection service for a powered on VM when APD condition clears after APD timeout. This property is meaningful only when vSphere HA is turned on. Valid values are specified by VmReactionOnAPDCleared. The default value is VmReactionOnAPDCleared#none for cluster setting and VmReactionOnAPDCleared#useClusterDefault for per-VM setting.
vmStorageProtectionForAPD* | xsd:string | VM storage protection setting for storage failures categorized as All Paths Down (APD). APD is a condition where a storage has become inaccessible for unknown reasons. It only indicates loss of connectivity and does not indicate storage device failure or LUN removal (Permenant Device Loss or PDL). The details of APD and PDL are described in HostMountInfoInaccessibleReason. This property is meaningful only when vSphere HA is turned on. Valid values are specified by StorageVmReaction. The default value is StorageVmReaction#disabled for cluster setting and StorageVmReaction#clusterDefault for per-VM setting. When an APD condition happens and the host begins timing out I/Os (@link vim.host.MountInfo.InaccessibleReason#AllPathsDown_Timeout}, VM Component Protection service will react based on the specific value of this property: StorageVmReaction#disabled, no reaction, i.e., no VM failover and no event reporting for the failures. StorageVmReaction#warning, service will issue events, alarms and/or config issues for component failures. StorageVmReaction#restartConservative, service will terminate the impacted VMs after a preconfigured time interval (vmTerminateDelayForAPDSec) if they are to be restarted. StorageVmReaction#restartAggressive, service might terminate the impacted VMs after a preconfigured time interval (vmTerminateDelayForAPDSec). In some cases, a VM is terminated even if it may not able to be restarted or lose Fault Tolerance redundancy. StorageVmReaction#clusterDefault, service will implement cluster default.
vmStorageProtectionForPDL* | xsd:string | VM storage protection setting for storage failures categorized as Permenant Device Loss (PDL). PDL indicates storage device failure or LUN removal. In case of PDL, the failed datastore or device is unlikely to recover. The details of PDL are described in HostMountInfoInaccessibleReason. This property is meaningful only when vSphere HA is turned on. Valid values are StorageVmReaction#disabled, StorageVmReaction#warning, StorageVmReaction#restartAggressive and StorageVmReaction#clusterDefault. The default value is StorageVmReaction#disabled for cluster setting and StorageVmReaction#clusterDefault for per-VM setting. When set to StorageVmReaction#restartAggressive, VM Component Protection service will immediately terminate the VMs impacted by PDL and will attempt to restart the VMs with best effort. When set to the other values, the behavior is the same as described for vmStorageProtectionForAPD.
vmTerminateDelayForAPDSec* | xsd:int | The time interval after an APD timeout has been declared and before VM Component Protection service will terminate the VM. The value only applies if vmStorageProtectionForAPD is set to StorageVmReaction#restartConservative or StorageVmReaction#restartAggressive. The default value is 180 seconds if not specified. To use cluster setting for a VM override, set to -1 in per-VM setting.
Properties inherited from DynamicData
None

*Need not be set
Show WSDL type definition
<complexType xmlns="http://www.w3.org/2001/XMLSchema" xmlns:vslm="urn:vslm" name="ClusterVmComponentProtectionSettings"> <complexContent> <extension base="vslm:DynamicData"> <sequence> <element name="vmStorageProtectionForAPD" type="xsd:string" minOccurs="0"/> <element name="enableAPDTimeoutForHosts" type="xsd:boolean" minOccurs="0"/> <element name="vmTerminateDelayForAPDSec" type="xsd:int" minOccurs="0"/> <element name="vmReactionOnAPDCleared" type="xsd:string" minOccurs="0"/> <element name="vmStorageProtectionForPDL" type="xsd:string" minOccurs="0"/> </sequence> </extension> </complexContent> </complexType>